#max_cycle.jl
#julia to find max cycle
# Tom Davidoff
# 03/06/15

using DataFrames

a = readtable("docs/supply_instrument/data/for_julia.csv")
a = a[a[:month].==1,:]
for j in unique(a[:cbsa_name])
	tester=0
	best_start=0
	best_peak=0
	best_stop=0
	b = a[a[:cbsa_name].==j,:]
	for start in unique(b[:year])
		for peak in ((start+1):(maximum(b[:year])-1))
			for ender in ((peak+1):maximum(b[:year]))
				peak_val = b[:fmhpi][b[:year].==peak][1]
				start_val = b[:fmhpi][b[:year].==start][1]
				stop_val = b[:fmhpi][b[:year].==ender][1]
				newtest = log(peak_val/start_val)/(peak-start) - log(stop_val/peak_val)/(ender-peak)
				if newtest>tester
					best_start=start
					best_peak=peak
					best_stop=ender
					tester=newtest 
				end
			end
		end
	end
	print("\"",j,"\"",";",tester,";",best_start,";",best_peak,";",best_stop,"\n")
end

		



